<?php 
if (isset($_GET['code'])) { die(highlight_file(__FILE__, 1)); }  
############################################################################ 
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-USA template set) 
############################################################################ 
# 
#   Project:    Sample Included Website Design 
#   Module:     sample.php 
#   Purpose:    Sample Page 
#   Authors:    Kevin W. Reed <kreed@tnet.com> 
#               TNET Services, Inc. 
# 
#     Copyright:    (c) 1992-2007 Copyright TNET Services, Inc. 
############################################################################ 
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software 
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA 
############################################################################ 
#    This document uses Tab 4 Settings 
############################################################################ 
require_once("Settings.php"); 
//require_once("common.php"); 
############################################################################ 
$TITLE= $SITE['organ'] . " - Temperaure Trending - Annual Departure from Average";
$loc = "./";                   # Location of dailynoaareport*.htm   
$showGizmo = true;  // set to false to exclude the gizmo 
include("top.php");
$startDate = " since 2005"; // set to date when data was first recorded
$stationName = "Relay, Maryland"; // set to name you want used in this report
$temp_places = 2; // set to how many decimal places for temperature  
############################################################################
############################################################################ 
$uomTemp = $SITE[uomTemp]; // set here in case gizmo is not used
$uomRain = $SITE[uomRain]; // set here in case gizmo is not used 
$imagesDir = $SITE[imagesDir];  // set here in case gizmo is not used 
?> 
</head> 
<body> 
<?php 
############################################################################ 
include("header.php"); 
############################################################################ 
include("menubar.php"); 
############################################################################ 
?> 

<div id="main-copy">
	<h3>Global Warming Trending for Relay, Maryland</h3>
	<img src="Relay_logo_85.png" align="right" border="0" width="55" height="55" alt="" /><br />
<hr id="snippets-1" />
<br />
Note: Trends are based on data recorded at <?php echo $stationName . $startDate . "." ?>  
<br />
<br />
<br />
<br />
<?php $places = $temp_places;  
$today = getdate();
$year = $today[year];
$month = $today[mon];
$day = $today[mday];
?>  
<div align="center"> 
<div style="width: 632px;"> 
      <table width="650" border="0" cellpadding="2" cellspacing="1" 
style="border:solid; border-color: #CCCCCC;"> 
<tr> 
<td class="table-top" nowrap="nowrap" style="text-align:center;" 
colspan="4">Annual Temperature Trend</td> 
</tr> 
<tr class="table-top" style="text-align:center;"> 
<td >Month</td> 
<td ><?php echo 'Average' . $startDate; ?></td> 
<td ><?php echo 'Current Month'; ?></td> 
<td ><?php echo 'Difference'; ?></td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >January</td> 
<td ><?php echo ($avtempjan) . $uomTemp;?></td> 
<td ><?php echo ($avtempjannow) . $uomTemp . ' (' . ($year - ($month < 1)) .')';?></td>
<td ><span class="ajax" id="ajaxjandiff"><?php echo 
trends_gen_difference($avtempjannow, $avtempjan, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >February</td> 
<td ><?php echo ($avtempfeb) . $uomTemp;?></td> 
<td ><?php echo ($avtempfebnow) . $uomTemp . ' (' . ($year - ($month < 2)) .')';?></td>
<td ><span class="ajax" id="ajaxfebdiff"><?php echo 
trends_gen_difference($avtempfebnow, $avtempfeb, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;">March</td>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;"><?php echo ($avtempmar) . $uomTemp;?></td>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;"><?php echo ($avtempmarnow) . $uomTemp . ' (' . ($year - ($month < 3)) .')';?></td>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;">
	<span class="ajax" id="ajaxmardiff"><?php echo trends_gen_difference($avtempmarnow, $avtempmar, $uomTemp,
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >April</td> 
<td ><?php echo ($avtempapr) . $uomTemp;?></td> 
<td ><?php echo ($avtempaprnow) . $uomTemp . ' (' . ($year - ($month < 4)) .')';?></td>
<td ><span class="ajax" id="ajaxaprdiff"><?php echo 
trends_gen_difference($avtempaprnow, $avtempapr, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >May</td> 
<td ><?php echo ($avtempmay) . $uomTemp;?></td> 
<td ><?php echo ($avtempmaynow) . $uomTemp . ' (' . ($year - ($month < 5)) .')';?></td>
<td ><span class="ajax" id="ajaxmaydiff"><?php echo 
trends_gen_difference($avtempmaynow, $avtempmay, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >June</td> 
<td ><?php echo ($avtempjun) . $uomTemp;?></td> 
<td ><?php echo ($avtempjunnow) . $uomTemp . ' (' . ($year - ($month < 6)) .')';?></td>
<td ><span class="ajax" id="ajaxjunf"><?php echo trends_gen_difference($avtempjunnow, 
$avtempjun, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >July</td> 
<td ><?php echo ($avtempjul) . $uomTemp;?></td> 
<td ><?php echo ($avtempjulnow) . $uomTemp . ' (' . ($year - ($month < 7)) .')';?></td>
<td >    <span class="ajax" id="ajaxjuldiff"><?php echo 
trends_gen_difference($avtempjulnow, $avtempjul, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >August</td> 
<td ><?php echo ($avtempaug) . $uomTemp;?></td> 
<td ><?php echo ($avtempaugnow) . $uomTemp . ' (' . ($year - ($month < 8)) .')';?></td>
<td >    <span class="ajax" id="ajaxaugdiff"><?php echo 

trends_gen_difference($avtempaugnow, $avtempaug, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >September</td> 
<td ><?php echo ($avtempsep) . $uomTemp;?></td> 
<td ><?php echo ($avtempsepnow) . $uomTemp . ' (' . ($year - ($month < 9)) .')';?></td>
<td ><span class="ajax" id="ajaxsepdiff"><?php echo 
trends_gen_difference($avtempsepnow, $avtempsep, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >October</td> 
<td ><?php echo ($avtempoct) . $uomTemp;?></td> 
<td ><?php echo ($avtempoctnow) . $uomTemp . ' (' . ($year - ($month < 10)) .')';?></td>
<td ><span class="ajax" id="ajaxoctdiff"><?php echo 
trends_gen_difference($avtempoctnow, $avtempoct, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >November</td> 
<td ><?php echo ($avtempnov) . $uomTemp;?></td> 
<td ><?php echo ($avtempnovnow) . $uomTemp . ' (' . ($year - ($month < 11)) .')';?></td>
<td ><span class="ajax" id="ajaxnovdiff"><?php echo 
trends_gen_difference($avtempnovnow, $avtempnov, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >December</td> 
<td ><?php echo ($avtempdec) . $uomTemp;?></td> 
<td ><?php echo ($avtempdecnow) . $uomTemp . ' (' . ($year - ($month < 12)) .')';?></td>
<td ><span class="ajax" id="ajaxdecdiff"><?php echo 
trends_gen_difference($avtempdecnow, $avtempdec, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<?php 
$alltimeaverage = array($avtempjan,$avtempfeb,$avtempmar,$avtempapr,$avtempmay,$avtempjun,$avtempjul,$avtempaug,$avtempsep,$avtempoct,$avtempnov,$avtempdec);
$currentmonthaverage = array($avtempjannow,$avtempfebnow,$avtempmarnow,$avtempaprnow,$avtempmaynow,$avtempjunnow,$avtempjulnow,$avtempaugnow,$avtempsepnow,
                                $avtempoctnow,$avtempnovnow,$avtempdecnow);
                                                               
$avtempalltime = get_yearly_avg ($alltimeaverage,$day, $month, $year); 
$avtempalltime = round($avtempalltime,1); 

// The avtempxxxnow custom tag for the current month is only a partial month average, so make it a complete month by using the dailynoaareports
$currentmonthaverage[$month-1] = adjust_current_month($currentmonthaverage[$month-1],$day,$month,$year,$loc); 
$monthtemptrend = get_yearly_avg ($currentmonthaverage,$day, $month, $year); 
$monthtemptrend = round($monthtemptrend,1); 
?>


<tr class="column-light" style="text-align: center; font-size: 8pt;"> 

<td colspan="4" > 
<?php echo "Average 12 Month Temperature" . $startDate . ": " . $avtempalltime  . $uomTemp;?> 
</td> 
</tr> 
 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
<?php echo "Current 12 Month Temperature: " . $monthtemptrend . $uomTemp;?> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
<?php echo 'Current 12 Month Temperature Trend: '; ?> 
  <span class="ajax" id="ajaxtotaldiff2"><?php echo 
trends_gen_difference($monthtemptrend, $avtempalltime, $uomTemp, 
                '%s'.$uomTemp.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomTemp.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
</table> 
<br />
</div> 
<br /> 
<span style="font-size: 9px;">This table is reflective of 12 month trending at the <?php echo $stationName ?> Weather Station location.  This is not official scientific data.  The weather data presented here is based on data collected <?php echo $startDate; ?>.  Script courtesy of:  <strong>Michael 
Holden</strong> from  <span class='link'><a href='http://www.relayweather.com/' 
>www.relayweather.com</a>.  Script calculations courtesy of:  <strong>Murry 
Conarroe</strong> from  <span class='link'><a href='http://weather.wildwoodnaturist.com' 
>weather.wildwoodnaturist.com</a>.</span></span> 
</div> 
</div><!-- end main-copy --> 


<?php 
############################################################################ 
include("footer.php"); 
############################################################################ 
# End of Page 
############################################################################
########## Functions ##########################################################
//=========================================================================
//  generate an up/down arrow to show differences

function trends_gen_difference( $nowTemp, $yesterTemp, $Legend, $textUP, $textDN) {
  global $imagesDir;
  global $places;
  $diff = round(($nowTemp - $yesterTemp),2) ; 
  $diff = number_format($diff,$places);
  $absDiff = abs($diff);
 
  if ($diff == 0) {
     // no change
     $image = '&nbsp;'; 
     }
  elseif ($diff > 0) {
    // today is greater 
    $msg = sprintf($textUP,$absDiff); 
    $image = "<img src=\"${imagesDir}rising.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";
    }
  else {
    // today is lesser
    $msg = sprintf($textDN,$absDiff); 
    $image = "<img src=\"${imagesDir}falling.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";
    }
    
   if ($Legend) {
       return ($diff . $Legend . $image);
    } else {
       return $image;
    }
}

function get_yearly_avg ($values,$day, $month, $year){
    $days = array(31,28,31,30,31,30,31,31,30,31,30,31);
    $days[1] = get_days_in_month(2,($year-($month == 1)));  // adjust for leap year if needed
// All months were not created equal, so convert to days         
    $total_days = array_sum($days);
        for ( $i = 0; $i < 12 ; $i ++ ) { 
        $total_degrees = $total_degrees + ($values[$i]*$days[$i]);
    }
    return $total_degrees/$total_days;   
} 

function get_days_in_month($month, $year)
{
   return $month == 2 ? ($year % 4 ? 28 : ($year % 100 ? 29 : ($year %400 ? 28 : 29))) : (($month - 1) % 7 % 2 ? 30 : 31);
}
     
function adjust_current_month ($current_value,$day,$month,$year,$loc)
{
// The avgtempxxxnow customtag is only a partial month, so use the dailynoaareport files to get a complete month
$filename = "dailynoaareport" . ( $month) . ($year - 1) . ".htm";
$filename2 = "dailynoaareport.htm";
$new_value = $current_value;

if (file_exists($loc . $filename) )   // If no file found, use the $current_value customtag for the month average
    {
    $data[0] = getnoaafile($loc . $filename);
    // Get mean temps for this month of the previous year from today to end of month
    $days = get_days_in_month($month,($year-1)); 
    for ($i = $day-1 ; $i < $days ; $i++)
        {
        $temp = $data[0][$i][1];
        if ($temp != "")
            {
            $temps = $temps + $data[0][$i][1];
            $count = $count + 1;
            } 
        }
    // Now get data from the dailynoaareport for this month from the 1st to yesterday.
    if ($day > 1)    // There is no data in the dailynoaareport file on the first day of the month
        {
        if (file_exists($loc . $filename2) ) 
            {
            $data[1] = getnoaafile($loc . $filename2); 
            for ($i = 0 ; $i < $day ; $i++)
                {
                $temp = $data[1][$i][1];
                if ($temp != "")
                    {
                    $temps = $temps + $data[1][$i][1];
                    $count = $count + 1; 
                    }   
                }
            }
        else  // No dailynoaareport file found. So use the $current_value customtag for the beginning portion of the month
            {
            $temp = $current_value;
            $temps = $temps + ($temp * ($day - 1));
            $count = $count + $day;     
            }
        }
    // Now combine the two sections
    $new_value = $temps/$count;    
    } 
              
return $new_value;    
} 
        
 # GETNOAAFILE function
# Developed by TNETWeather.com
#
# Returns an array of the contents of the specified filename
# Array contains days from 1 - 31 (or less if the month has less) and
# the values:
# Day
# Mean Temp
# High Temp
# Time of High Temp
# Low Temp
# Time of Low Temp
# Hot Degree Day
# Cold Degree Day
# Rain
# Avg Wind Speed
# High Wind
# Time High Wind
# Dom Wind Direction
############################################################################

function getnoaafile ($filename) {
    global $SITE;               
    
    $rawdata = array();
    
    $fd = @fopen($filename,'r');
    
    $startdt = 0;
    if ( $fd ) {
    
        while ( !feof($fd) ) { 
        
            // Get one line of data
            $gotdat = trim ( fgets($fd,8192) );
            
            if ($startdt == 1 ) {
                if ( strpos ($gotdat, "--------------" ) !== FALSE ){
                    $startdt = 2;
                } else {
                    $foundline = preg_split("/[\n\r\t ]+/", $gotdat );                    
                    $rawdata[intval ($foundline[0]) -1 ] = $foundline;
                }
            }
        
            if ($startdt == 0 ) {
                if ( strpos ($gotdat, "--------------" ) !== FALSE ){
                    $startdt = 1;
                } 
            }
        }
        // Close the file we are done getting data
        fclose($fd);
    }   
    return($rawdata);
}  

         
############################################################################

?>  