<?php 
if (isset($_GET['code'])) { die(highlight_file(__FILE__, 1)); }  
############################################################################ 
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-USA template set) 
############################################################################ 
# 
#   Project:    Sample Included Website Design 
#   Module:     sample.php 
#   Purpose:    Sample Page 
#   Authors:    Kevin W. Reed <kreed@tnet.com> 
#               TNET Services, Inc. 
# 
#     Copyright:    (c) 1992-2007 Copyright TNET Services, Inc. 
############################################################################ 
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License 
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software 
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA 
############################################################################ 
#    This document uses Tab 4 Settings 
############################################################################ 
require_once("Settings.php"); 
//require_once("common.php"); 
############################################################################ 
$TITLE= $SITE['organ'] . " - Annual Departure from Average";
$showGizmo = true;  // set to false to exclude the gizmo 
$startDate = " since 2005"; // set to date when data was first recorded
$stationName = "Relay, Maryland"; // set to name you want used in this report
$rain_places = 2; // set to how many decimal places for rain
############################################################################ 
$uomTemp = $SITE[uomTemp]; // set here in case gizmo is not used
$uomRain = $SITE[uomRain]; // set here in case gizmo is not used 
$imagesDir = $SITE[imagesDir];  // set here in case gizmo is not used
include("top.php"); 
############################################################################ 
?> 
</head> 
<body> 
<?php 
############################################################################ 
include("header.php"); 
############################################################################ 
include("menubar.php"); 
############################################################################
include("raintodate.php"); 
############################################################################  
?> 

<div id="main-copy">
<h3>Rain Trending for Relay, Maryland</h3>
	<img src="Relay_logo_85.png" align="right" border="0" width="55" height="55" alt="" /><br />
<hr id="snippets-1" />
<br />
Note: Trends are based on data recorded at <?php echo $stationName . $startDate . "." ?>   
<!-- <img src="Relay_logo_85.png" align="right" border="0" width="55" height="55" alt="" /><br /> -->
<br />
<br />
<br />
<br />
<?php $places = $temp_places;  
$today = getdate();
$year = $today[year];
$month = $today[mon];
$day = $today[mday];
?>  
<div align="center"> 
<div style="width: 632px;"> 

<!-- Rainfall Table -->
<?php $places = $rain_places; // Two decimal place for rain   ?> 
<table width="650" border="0" cellpadding="2" cellspacing="1" 
style="border:solid; border-color: #CCCCCC;"> 
<tr> 
<td class="table-top" nowrap="nowrap" style="text-align:center;" 
colspan="4">Annual Rainfall Trend</td> 
</tr> 
<tr class="table-top" style="text-align:center;"> 
<td >Month</td> 
<td ><?php echo 'Average' . $startDate; ?></td> 
<td ><?php echo 'Current Month'; ?></td> 
<td ><?php echo 'Difference'; ?></td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >January</td> 
<td ><?php echo ($avrainjan) . $uomRain;?></td> 
<td ><?php echo ($avrainjannow) . $uomRain . ' (' . ($year - ($month < 1)) .')';?></td>
<td ><span class="ajax" id="ajaxjandiffr"><?php echo 
trends_gen_difference($avrainjannow, $avrainjan, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >February</td> 
<td ><?php echo ($avrainfeb) . $uomRain;?></td> 
<td ><?php echo ($avrainfebnow) . $uomRain . ' (' . ($year - ($month < 2)) .')';?></td>
<td ><span class="ajax" id="ajaxfebdiffr"><?php echo 
trends_gen_difference($avrainfebnow, $avrainfeb, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;">March</td>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;"><?php echo ($avrainmar) . $uomRain;?></td>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;"><?php echo ($avrainmarnow) . $uomRain . ' (' . ($year - ($month < 3)) .')';?></td>
<td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt; width: 25%;">
    <span class="ajax" id="ajaxmardiffr"><?php echo trends_gen_difference($avrainmarnow, $avrainmar, $uomRain,
                '%s'.$uomRain.' Warmer than All-Time Average Temperature.', 
               '%s'.$uomRain.' Colder than All-Time Average Temperature.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >April</td> 
<td ><?php echo ($avrainapr) . $uomRain;?></td> 
<td ><?php echo ($avrainaprnow) . $uomRain . ' (' . ($year - ($month < 4)) .')';?></td>
<td ><span class="ajax" id="ajaxaprdiffr"><?php echo 
trends_gen_difference($avrainaprnow, $avrainapr, $uomRain, 
                 '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >May</td> 
<td ><?php echo ($avrainmay) . $uomRain;?></td> 
<td ><?php echo ($avrainmaynow) . $uomRain . ' (' . ($year - ($month < 5)) .')';?></td>
<td ><span class="ajax" id="ajaxmaydiffr"><?php echo 
trends_gen_difference($avrainmaynow, $avrainmay, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.');  
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >June</td> 
<td ><?php echo ($avrainjun) . $uomRain;?></td> 
<td ><?php echo ($avrainjunnow) . $uomRain . ' (' . ($year - ($month < 6)) .')';?></td>
<td ><span class="ajax" id="ajaxjunfr"><?php echo trends_gen_difference($avrainjunnow, 
$avrainjun, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >July</td> 
<td ><?php echo ($avrainjul) . $uomRain;?></td> 
<td ><?php echo ($avrainjulnow) . $uomRain . ' (' . ($year - ($month < 7)) .')';?></td>
<td >    <span class="ajax" id="ajaxjuldiffr"><?php echo 
trends_gen_difference($avrainjulnow, $avrainjul, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.');  
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >August</td> 
<td ><?php echo ($avrainaug) . $uomRain;?></td> 
<td ><?php echo ($avrainaugnow) . $uomRain . ' (' . ($year - ($month < 8)) .')';?></td>
<td >    <span class="ajax" id="ajaxaugdiffr"><?php echo 

trends_gen_difference($avrainaugnow, $avrainaug, $uomRain, 
                 '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >September</td> 
<td ><?php echo ($avrainsep) . $uomRain;?></td> 
<td ><?php echo ($avrainsepnow) . $uomRain . ' (' . ($year - ($month < 9)) .')';?></td>
<td ><span class="ajax" id="ajaxsepdiffr"><?php echo 
trends_gen_difference($avrainsepnow, $avrainsep, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >October</td> 
<td ><?php echo ($avrainoct) . $uomRain;?></td> 
<td ><?php echo ($avrainoctnow) . $uomRain . ' (' . ($year - ($month < 10)) .')';?></td>
<td ><span class="ajax" id="ajaxoctdiffr"><?php echo 
trends_gen_difference($avrainoctnow, $avrainoct, $uomRain, 
                 '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td >November</td> 
<td ><?php echo ($avrainnov) . $uomRain;?></td> 
<td ><?php echo ($avrainnovnow) . $uomRain . ' (' . ($year - ($month < 11)) .')';?></td>
<td ><span class="ajax" id="ajaxnovdiffr"><?php echo 
trends_gen_difference($avrainnovnow, $avrainnov, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td >December</td> 
<td ><?php echo ($avraindec) . $uomRain;?></td> 
<td ><?php echo ($avraindecnow) . $uomRain . ' (' . ($year - ($month < 12)) .')';?></td>
<td ><span class="ajax" id="ajaxdecdiffr"><?php echo 
trends_gen_difference($avraindecnow, $avraindec, $uomRain, 
                '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr>
<tr> 
<td class="table-top" nowrap="nowrap" style="text-align:center;" 
colspan="4"> 
12 Month Average Differentials 
</td> 
</tr>  
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<?php 
$alltimeaverage = 
$avrainjan+$avrainfeb+$avrainmar+$avrainapr+$avrainmay+$avrainjun+$avrainjul+$avrainaug+$avrainsep+$avrainoct+$avrainnov+$avraindec; 

$avrainalltime = $alltimeaverage / 1; 
$avrainalltime = number_format((round($avrainalltime,2)),$places); 
$currentmonthaverage = array($avrainjannow,$avrainfebnow,$avrainmarnow,$avrainaprnow,$avrainmaynow,$avrainjunnow,$avrainjulnow,
                                $avrainaugnow,$avrainsepnow,$avrainoctnow,$avrainnovnow,$avraindecnow); 

// The avtempxxxnow custom tag for the current month is only a partial month average, so make it a complete month by using the dailynoaareports
$currentmonthaverage[$month-1] = adjust_current_month($currentmonthaverage[$month-1],$day,$month,$year,$loc); 
$monthraintrend = array_sum($currentmonthaverage); 
$monthraintrend = number_format((round($monthraintrend,2)),$places);
?> 
<td colspan="4" > 
<?php echo "Average 12 Month Rainfall" . $startDate . ": " . $avrainalltime  . $uomRain;?> 
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
<?php echo "Rainfall for last 12 months: " . $monthraintrend . $uomRain;?> 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
<?php echo 'Current 12 Month Rainfall difference: '; ?> 
  <span class="ajax" id="ajaxtotaldiff2r"><?php echo 
trends_gen_difference($monthraintrend, $avrainalltime, $uomRain, 
                 '%s'.$uomRain.' more than All-Time Average Rainfall.', 
               '%s'.$uomRain.' less than All-Time Average Rainfall.'); 
?></span> 
</td> 
</tr>
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" >&nbsp;&nbsp;&nbsp;&nbsp;
</td> 
</tr>
<?php
// Start Rain Differential Section of Table
$avg_ytd_rain =  round($avg_ytd_rain,3);
$avg_ytd_rain =  number_format($avg_ytd_rain, 2, '.', '');
$yearrn =  round($yearrn,3);
$yearrn =  number_format($yearrn, 2, '.', '');
$avg_mtd_rain =  round($avg_mtd_rain,3);
$avg_mtd_rain =  number_format($avg_mtd_rain, 2, '.', '');
$monthrn =  round($monthrn,3);
$monthrn =  number_format($monthrn, 2, '.', '');

?>
<tr> 
<td class="table-top" nowrap="nowrap" style="text-align:center;" 
colspan="4"> 
Year Rain Differentials 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
Average Year to Date Rain based on historical data since 2005: &nbsp;&nbsp; <?php print $avg_ytd_rain . $uomRain; ?>
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
Current Year to Date Rain (<?php print $year; ?>): &nbsp;&nbsp; <?php print $yearrn . $uomRain; ?>
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
Current Year to Date Departure from Normal (<?php print $year; ?>): &nbsp;&nbsp; 
<?php $yearrndifference=round(($yearrn-$avg_ytd_rain),2);
				  if ($yearrndifference >= 0)
				     echo "+";
				   else
				     echo ""; 
                                   ?>
				  <?php echo "$yearrndifference" . $uomRain; 
				  if ($yearrndifference >= 0)
				     echo '&nbsp;<img src="http://www.relayweather.com/ajax-images/rising.gif" border="0" width="7" height="8" alt="" />';
				   else
				     echo '&nbsp;<img src="http://www.relayweather.com/ajax-images/falling.gif" border="0" width="7" height="8" alt="" />'; 
				     ?>
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > &nbsp;&nbsp;
</td> 
</tr>
<tr> 
<td class="table-top" nowrap="nowrap" style="text-align:center;" 
colspan="4"> 
Month Rain Differentials 
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
Average Month to Date Rain based on historical data since 2005: &nbsp;&nbsp;   
<?php print $avg_mtd_rain . $uomRain; ?>
</td> 
</tr> 
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
Current Month to Date Rain (<?php echo date("F");?>): &nbsp;&nbsp; 
<?php print $monthrn . $uomRain; ?>
</td> 
</tr> 
<tr class="column-light" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > 
Current Month to Date Departure from Normal (<?php echo date("F");?>): &nbsp;&nbsp;
<?php $monthrndifference=$monthrn-$avg_mtd_rain;
				  if ($monthrndifference >= 0)
				     echo "+";
				   else
				     echo ""; 
                                   ?>
				  <?php echo "$monthrndifference" . $uomRain; 
				  if ($monthrndifference >= 0)
				     echo '&nbsp;<img src="http://www.relayweather.com/ajax-images/rising.gif" border="0" width="7" height="8" alt="" />';
				   else
				     echo '&nbsp;<img src="http://www.relayweather.com/ajax-images/falling.gif" border="0" width="7" height="8" alt="" />'; 
          ?>
</td> 
</tr>
<tr class="column-dark" style="text-align: center; font-size: 8pt;"> 
<td colspan="4" > &nbsp;&nbsp;
</td> 
</tr> 
</table>
<table width="650">
<tr><td style="font-size: 9px;">This data is reflective of 12 month trending at the <?php echo $stationName ?> Weather Station location. This is not official scientific data.
 The weather data presented here is based on data collected <?php echo $startDate; ?>. Script courtesy of &nbsp;<strong>Michael Holden</strong> from  
<a href='http://www.relayweather.com/'>Relay Weather</a>. Script calculations courtesy of <strong> Murry Conarroe </strong>
 of <a href='http://weather.wildwoodnaturist.com/'>Wildwood Weather</a>.</td></tr>
</table>
<br/>
<br/>
<br/>
<iframe src="http://www.relayweather.com/WUgraphs/graphy6rt.php" width="640" height="500" scrolling="no" frameborder="0" name="iframe"></iframe>
<br/>
<br/>
<br/>
<iframe src="http://www.relayweather.com/WUgraphs/graphrain12avg.php" width="640" height="500" scrolling="no" frameborder="0" name="iframe"></iframe>
<br/>
<br/>
<br />
<br />
<br />  
</div> 
</div> 
</div><!-- end main-copy --> 

<?php 
############################################################################ 
include("footer.php"); 
############################################################################ 
########## Functions ##########################################################
//=========================================================================
//  generate an up/down arrow to show differences

function trends_gen_difference( $nowTemp, $yesterTemp, $Legend, $textUP, $textDN) {
  global $imagesDir;
  global $places;
  $diff = round(($nowTemp - $yesterTemp),2) ; 
  $diff = number_format($diff,$places);
  $absDiff = abs($diff);
 
  if ($diff == 0) {
     // no change
     $image = '&nbsp;'; 
     }
  elseif ($diff > 0) {
    // today is greater 
    $msg = sprintf($textUP,$absDiff); 
    $image = "<img src=\"${imagesDir}rising.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";
    }
  else {
    // today is lesser
    $msg = sprintf($textDN,$absDiff); 
    $image = "<img src=\"${imagesDir}falling.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";
    }
    
   if ($Legend) {
       return ($diff . $Legend . $image);
    } else {
       return $image;
    }
}

function get_days_in_month($month, $year)
{
   return $month == 2 ? ($year % 4 ? 28 : ($year % 100 ? 29 : ($year %400 ? 28 : 29))) : (($month - 1) % 7 % 2 ? 30 : 31);
}
     
function adjust_current_month ($current_rain,$day,$month,$year,$loc)
{
// The avgtempxxxnow customtag is only a partial month, so use the dailynoaareport files to get a complete month
$filename = "dailynoaareport" . ( $month) . ($year - 1) . ".htm";
$filename2 = "dailynoaareport.htm";


if (file_exists($loc . $filename) )   // If no file found, use the $current_value customtag for the month average
    {
    $data[0] = getnoaafile($loc . $filename);
    // Get data for this month of the previous year from today to end of month
    $days = get_days_in_month($month,($year-1)); 
    for ($i = $day-1 ; $i < $days ; $i++)
        {
        $rain = $data[0][$i][8];
        if ($rain != "")
            {
            $new_rain = $new_rain + $rain;
            } 
        }
    // Now get data from the dailynoaareport for this month from the 1st to yesterday.
    if ($day > 1)    // There is no data in the dailynoaareport file on the first day of the month
        {
        if (file_exists($loc . $filename2) ) 
            {
            $data[1] = getnoaafile($loc . $filename2); 
            for ($i = 0 ; $i < $day ; $i++)
                {
                $rain = $data[1][$i][8];
                if ($rain != "")
                    {
                    $new_rain = $new_rain + $rain;                     
                    }   
                }
            }
        else  // No dailynoaareport file found. So use the customtag for the beginning portion of the month
            {
            $new_rain = $new_rain + $current_rain;  
            }
        }
   
    } 
    else
    {
      $new_rain = $current_rain;  // If noaadailyreportmyyyy file not found, use the customtag info
    }          
return $new_rain;    
} 
        
 # GETNOAAFILE function
# Developed by TNETWeather.com
#
# Returns an array of the contents of the specified filename
# Array contains days from 1 - 31 (or less if the month has less) and
# the values:
# Day
# Mean Temp
# High Temp
# Time of High Temp
# Low Temp
# Time of Low Temp
# Hot Degree Day
# Cold Degree Day
# Rain
# Avg Wind Speed
# High Wind
# Time High Wind
# Dom Wind Direction
############################################################################

function getnoaafile ($filename) {
    global $SITE;               
    
    $rawdata = array();
    
    $fd = @fopen($filename,'r');
    
    $startdt = 0;
    if ( $fd ) {
    
        while ( !feof($fd) ) { 
        
            // Get one line of data
            $gotdat = trim ( fgets($fd,8192) );
            
            if ($startdt == 1 ) {
                if ( strpos ($gotdat, "--------------" ) !== FALSE ){
                    $startdt = 2;
                } else {
                    $foundline = preg_split("/[\n\r\t ]+/", $gotdat );                    
                    $rawdata[intval ($foundline[0]) -1 ] = $foundline;
                }
            }
        
            if ($startdt == 0 ) {
                if ( strpos ($gotdat, "--------------" ) !== FALSE ){
                    $startdt = 1;
                } 
            }
        }
        // Close the file we are done getting data
        fclose($fd);
    }   
    return($rawdata);
}  

          
############################################################################ 
# End of Page 
############################################################################ 

?>  
